/*
 Copyright (c) Information Equipment co.,LTD.
 Code by JaeHyuk Cho <mailto:minzkn@infoeq.co.kr> KOREA
*/

#ifndef DEF_SOURCE_cpuusage_c
#define DEF_SOURCE_cpuusage_c "cpuusage.c"

#include "cpuusage.h"

int MZ_GetCPU_StatBuffer(void *s_Buffer, int s_Length);
int MZ_GetCPU_Parse(char s_How, void *s_Buffer, t_CPU_Tick *s_CPU_Tick);
void MZ_GetCPU_MakeSubInfo(t_CPU_Tick *s_SubInfo, const t_CPU_Tick *s_OldInfo, const t_CPU_Tick *s_NewInfo);

int MZ_GetCPU_StatBuffer(void *s_Buffer, int s_Length)
{
 const char c_Proc_CPU_Stat[] = "/proc/stat";	
 int s_Handle, s_ReadBytes;
 s_Handle = open(c_Proc_CPU_Stat, O_RDONLY); 
 if(s_Handle >= 0)
 {
  s_ReadBytes = read(s_Handle, s_Buffer, s_Length - 1);
  close(s_Handle);
  if(s_ReadBytes > 0)*(((char *)s_Buffer) + s_ReadBytes) = '\0';	 
 }
 else s_ReadBytes = (-1);
 return(s_ReadBytes); 
}

int MZ_GetCPU_Parse(char s_How, void *s_Buffer, t_CPU_Tick *s_CPU_Tick)
{
 char s_HowCPU[ 3 + 1 + 1 ], *s_CPU_Entry;
 int s_Return = 0, s_Check;
 sprintf((char *)(&s_HowCPU[0]), "cpu%c", s_How);
 s_CPU_Entry = strstr((char *)s_Buffer, (char *)(&s_HowCPU[0]));
 if(s_CPU_Entry)
 {
  s_Check = sscanf(s_CPU_Entry, "%s %lu %lu %lu %lu", (char *)(&s_HowCPU[0]),
                   (unsigned long *)(&s_CPU_Tick->User), (unsigned long *)(&s_CPU_Tick->Nice),
                   (unsigned long *)(&s_CPU_Tick->System), (unsigned long *)(&s_CPU_Tick->Idle));
  if(s_Check == 5)
  {
   s_CPU_Tick->How = s_How;	  
   s_CPU_Tick->Total = s_CPU_Tick->User + s_CPU_Tick->Nice + s_CPU_Tick->System + s_CPU_Tick->Idle;
   s_Return = 1;
  }
 }
 return(s_Return); 
}

void MZ_GetCPU_MakeSubInfo(t_CPU_Tick *s_SubInfo, const t_CPU_Tick *s_OldInfo, const t_CPU_Tick *s_NewInfo)
{
 s_SubInfo->How = s_NewInfo->How;
 #define __DEF_CPU_SUBINFO__(this) do{s_SubInfo->this = s_NewInfo->this - s_OldInfo->this;}while(0) 
 __DEF_CPU_SUBINFO__(User);   __DEF_CPU_SUBINFO__(Nice);
 __DEF_CPU_SUBINFO__(System); __DEF_CPU_SUBINFO__(Idle);
 __DEF_CPU_SUBINFO__(Total);
 #undef __DEF_CPU_SUBINFO__
 memcpy((void *)s_OldInfo, (void *)s_NewInfo, sizeof(t_CPU_Tick));
}

#endif

/* End of source */
